' the 128-bit pc1 encryption algorithm
' written with PIC Simulator IDE 4.2
' (c) Alexander Pukall 1991-2004
' Code free for all, even for commercial applications

Dim x1a0(8) As Word
Dim cle(16) As Byte
Dim inputalgo(9) As Byte ' the text to encrypt or decrypt
Dim outputalgo(9) As Byte ' the resulted encrypted or decrypted text
Dim x1a2 As Word

Dim inter As Word
Dim res As Word
Dim ax As Word
Dim bx As Word
Dim cx As Word
Dim dx As Word
Dim si As Word
Dim tmp As Word
Dim i As Byte
Dim fois As Byte
Dim cc As Byte
Dim compte As Byte
Dim nb As Byte
Dim nb1 As Byte
Dim atmp As Byte
Dim btmp As Byte
Dim bitmp As Bit
Dim a16tmp As Word
Dim b16tmp As Word
Dim modealgo As Byte ' modealgo = 1 encrypt, modealgo = 2 decrypt

' We choose to encrypt the text

' modealgo = 1 encrypt
' modealgo = 2 decrypt

modealgo = 1

' the key to encrypt the plaintext or decrypt the ciphertext

cle(0) = 78
cle(1) = 84
cle(2) = 45
cle(3) = 13
cle(4) = 124
cle(5) = 212
cle(6) = 49
cle(7) = 52
cle(8) = 178
cle(9) = 243
cle(10) = 17
cle(11) = 221
cle(12) = 74
cle(13) = 153
cle(14) = 237
cle(15) = 85

If modealgo = 1 Then

' the plaintext is 97 97 97 97 97 97 97 97 97 (in decimal) Or 'aaaaaaaa' (in ASCII)

inputalgo(0) = 97
inputalgo(1) = 97
inputalgo(2) = 97
inputalgo(3) = 97
inputalgo(4) = 97
inputalgo(5) = 97
inputalgo(6) = 97
inputalgo(7) = 97
inputalgo(8) = 97

Endif

If modealgo = 2 Then

' the ciphertext is 74 177 84 68 78 136 134 40 172 (in decimal)

inputalgo(0) = 74
inputalgo(1) = 177
inputalgo(2) = 84
inputalgo(3) = 68
inputalgo(4) = 78
inputalgo(5) = 136
inputalgo(6) = 134
inputalgo(7) = 40
inputalgo(8) = 172

Endif

' init the pc1 algorithm

si = 0
x1a2 = 0
i = 0

For fois = 0 To 8 ' from 0 to 8 = 9 bytes to encrypt or decrypt

cc = inputalgo(fois)
Gosub assemble

If modealgo = 1 Then

' xor the inputalgo byte with the key
' cle(compte) = cle(compte) xor cc

For compte = 0 To 15
atmp = cle(compte)
btmp = cc
Gosub xor8
cle(compte) = atmp
Next compte

Endif

' encrypt or decrypt the plaintext cc
' outputalgo(fois) = cc xor (inter.hb xor inter.lb)

atmp = inter.HB
btmp = inter.LB
Gosub xor8
btmp = atmp
atmp = cc
Gosub xor8
cc = atmp
outputalgo(fois) = cc

If modealgo = 2 Then

' xor the inputalgo byte with the key
' cle(compte) = cle(compte) xor cc

For compte = 0 To 15
atmp = cle(compte)
btmp = cc
Gosub xor8
cle(compte) = atmp
Next compte

Endif

Next fois

' the result encrypted or decrypted is in the outputalgo() tab

' End of the algorithm

End

xor8:

bitmp = atmp.0 Xor btmp.0
atmp.0 = bitmp
bitmp = atmp.1 Xor btmp.1
atmp.1 = bitmp
bitmp = atmp.2 Xor btmp.2
atmp.2 = bitmp
bitmp = atmp.3 Xor btmp.3
atmp.3 = bitmp
bitmp = atmp.4 Xor btmp.4
atmp.4 = bitmp
bitmp = atmp.5 Xor btmp.5
atmp.5 = bitmp
bitmp = atmp.6 Xor btmp.6
atmp.6 = bitmp
bitmp = atmp.7 Xor btmp.7
atmp.7 = bitmp

Return

xor16:

atmp = a16tmp.HB
btmp = b16tmp.HB
Gosub xor8
a16tmp.HB = atmp

atmp = a16tmp.LB
btmp = b16tmp.LB
Gosub xor8
a16tmp.LB = atmp

Return


assemble:

x1a0(0) = cle(0) * 256
x1a0(0) = x1a0(0) + cle(1)
Gosub code
inter = res

nb1 = 2

For nb = 1 To 7

nb = nb - 1
tmp = x1a0(nb)
nb = nb + 1
x1a0(nb) = cle(nb1) * 256
nb1 = nb1 + 1
x1a0(nb) = x1a0(nb) + cle(nb1)

' x1a0(nb) = x1a0(nb-1) xor tmp

a16tmp = x1a0(nb)
b16tmp = tmp
Gosub xor16
x1a0(nb) = a16tmp

Gosub code
nb1 = nb1 + 1

' inter = inter xor res

a16tmp = inter
b16tmp = res
Gosub xor16
inter = a16tmp

Next nb
i = 0

Return

code:

dx = x1a2 + i
ax = x1a0(i)
cx = 346
bx = 20021

tmp = ax
ax = si
si = tmp

tmp = ax
ax = dx
dx = tmp

If ax <> 0 Then
ax = ax * bx
Endif

tmp = ax
ax = cx
cx = tmp

If ax <> 0 Then
ax = ax * si
cx = ax + cx
Endif

tmp = ax
ax = si
si = tmp
ax = ax * bx
dx = cx + dx

ax = ax + 1

x1a2 = dx
x1a0(i) = ax

' res = ax xor dx

a16tmp = ax
b16tmp = dx
Gosub xor16
res = a16tmp

i = i + 1
Return

